; spell casting routines

!ifdef INCLUDE_CASTING !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_CASTING = 1
}

!zn Casting {

.text_castcancelmenu:
!tx TTOK_CONTINUE, 0
!tx TTOK_CANCEL_, TTOK_SPELL_, 0
!tx 0

.text_spfail:
!tx TTOK_SPELL_, "fails", 0
.text_spsucc:
!tx TTOK_SPELL_, "succeeds", 0

.text_fail:
.text_oor:
!tx "Out of range",0
.text_nolos:
!tx "No line of sight",0
.text_adjacent:
!tx "Adjacent",0
.text_ready:    ; not really fail...
!tx "Ready",0

.tbl_text_fail:
!by <.text_oor
!by <.text_nolos
!by <.text_adjacent
!by <.text_ready
.tbl_text_failh:
!by >.text_oor
!by >.text_nolos
!by >.text_adjacent
!by >.text_ready


cast_phase:
    jsr print_clear_status
    jsr set_current_player_index

    lda #0
    sta temp_cast_amount

    bit flag_player_cpu
    bpl +
    jsr do_ai_spell
    lda #10
    jsr delay
    clc
    rts
+
    ldx player_offs
    lda player_data + PDATA_OFFS_SELECTED_SPELL,x
    cmp #SPELL_INDEX_NONE
    clc
    bne +
    ; no spell selected
    rts
+   ; get the spell
;    clc
    adc player_offs
    tay
    lda player_data + PDATA_OFFS_SPELLS,y
    jsr set_spell
    jsr remove_spell
    jsr set_current_spell_chance
    jsr cast_print_spell_name
    ; wait key
-   jsr get_input
    beq -

    ; get illusion flag
    ldy #0
    ldx player_offs
    lda player_data + PDATA_OFFS_FLAGS2,x
    and #PDATA_MASK_FLAGS2_ILLUSION
    beq +
    ldy #$80
+   sty temp_illusion_flag

    jsr set_spell_success

    ; auto cast certain spells
    lda current_spell
    cmp #SPELL_MAGIC_WOOD
    beq .cast_phase_auto_1
    cmp #SPELL_TURMOIL
    beq .cast_phase_auto_1
    cmp #SPELL_MAGIC_SHIELD
    bcc ++
    cmp #SPELL_SHADOW_FORM + 1
    bcs ++

.cast_phase_auto_1:
    jsr print_setup_dst_area
    lda current_spell
    jsr spell_cast
    clc
    rts

++  ; quit if certain spells failed
    cmp #SPELL_VENGEANCE
    bcc ++
    cmp #SPELL_JUSTICE + 1
    bcs ++
    bit temp_success_flag
    bmi ++
    jsr cast_print_success_status
    lda #20
    jsr delay
    clc
    rts
++

.cast_phase_ask_target_loop:
    jsr arena_view_keep_coord
    ; if square is wizard itself, ask if continue / cancel spell
    cmp wcoord
    bne ++
    lda #COLOR_WHITE
    sta color
    jsr print_clear_status12
    ldx #<.text_castcancelmenu
    ldy #>.text_castcancelmenu
    jsr statusmenu
    cpy #1
    bcs .cast_phase_done
    ; continue
    jsr cast_print_spell_name_quiet
    jmp .cast_phase_ask_target_loop
++
    ; spell callback determines if square is ok
    jsr print_setup_dst_area
    lda current_spell
    jsr spell_cast
    ; cast amount is zero when we are done
    lda temp_cast_amount
    bne .cast_phase_ask_target_loop
    ; spell done
.cast_phase_done:
    ; redraw the arena
    jsr arena_draw
    jsr print_clear_status
    clc
    rts


; in:
; acoord = coord
; out:
; C = 0
cast_phase_arena_view_cb:
    ldx wcoord
    lda acoord
    jsr get_distance
    cmp current_spell_range
    ldy #STATUS3_OOR
    bcs .cast_phase_arena_view_cb_print
    ldx #0
    lda wcoord
    jsr los_blocked
    ldy #STATUS3_NOLOS
    bcc .cast_phase_arena_view_cb_print
    jsr is_tree_adjacent
    ldy #STATUS3_ADJACENT
    bcs .cast_phase_arena_view_cb_print
    jsr is_wall_adjacent
    ldy #STATUS3_ADJACENT
    bcs .cast_phase_arena_view_cb_print
    ; clc
    rts
.cast_phase_arena_view_cb_print:
    jmp print_text_status3


set_spell_success:
!if DEBUG_MAGIC_ALWAYS_WORKS = 0 {
    ldy #0
    bit temp_illusion_flag
    bmi +
    ; rnd < chance + 1      -> success
    ; rnd - chance - 1 < 0  -> success
    jsr get_random_10   ; rnd
    clc ; - 1
    sbc current_spell_chance    ; - chance
    bpl ++  ; < 0
}
    ; success, adjust world chaos
    lda current_spell
    asl
    tay
    lda spelldata_packed,y
    lsr
    lsr
    lsr
    lsr
    tay
    lda tbl_spelldata_chaos,y
    clc
    adc world_chaos
    sta world_chaos
+   ldy #$80
++  sty temp_success_flag
    rts


; in:
; a = spell id
; x = player_offs
; y = offset to spell to remove
remove_spell:
    ; remove spell if not disbelieve
    cmp #SPELL_DISBELIEVE
    beq +
    dec player_data + PDATA_OFFS_SPELL_COUNT,x
    ; calculate end offset: player_offs + (PDATA_LEN - PDATA_OFFS_SPELLS)
    txa
    clc
    adc #PDATA_LEN - PDATA_OFFS_SPELLS
    sta .remove_spell_end
    ; move next spells down one slot
-   lda player_data + PDATA_OFFS_SPELLS + 1,y
    sta player_data + PDATA_OFFS_SPELLS,y
    iny
.remove_spell_end = * + 1
    cpy #0 ;player_offs + (PDATA_LEN - PDATA_OFFS_SPELLS)
    bne -
+   rts


unselect_spell:
    lda #SPELL_INDEX_NONE
    ldx player_offs
    sta player_data + PDATA_OFFS_SELECTED_SPELL,x
    lda player_data + PDATA_OFFS_FLAGS2,x
    and #!PDATA_MASK_FLAGS2_ILLUSION
    sta player_data + PDATA_OFFS_FLAGS2,x
    rts


; in:
; current_spell = spell
cast_print_spell_name:
    lda #SND_SPELLSTEP
    jsr sound_play
cast_print_spell_name_quiet:
    jsr print_clear_status
    jsr print_setup_dst_statusline
    ; wizard name
    ldy player_i
    jsr print_wizard_name
    jsr print_setup_dst_next_line
    lda #8
    jsr delay
    ; spell name
    lda #COLOR_GREEN
    sta color
    lda current_spell
    jsr print_spellname_dst_ready
    lda #8
    jsr delay
    ; print range
    lda #COLOR_WHITE
    sta color
    inx
    stx zptmp
    lda current_spell
    jsr spell_get_range_for_print
    jsr print_number
    lda #8
    jsr delay
    jsr print_setup_dst_next_line
    rts



cast_print_success_status:
    ldx #<(vmatrix + POSY_STATUSLINE2 * COLS)
    ldy #>(vmatrix + POSY_STATUSLINE2 * COLS)
    jsr print_setup_dst_xy
    jsr print_clear_status2
    bit temp_success_flag
    bmi +
    lda #COLOR_PURPLE
    ldx #<.text_spfail
    ldy #>.text_spfail
    bne ++  ; bra
+   lda #COLOR_WHITE
    ldx #<.text_spsucc
    ldy #>.text_spsucc
++  sta color
    stx zptxt
    sty zptxth
    jsr print_packed_dst_ready
    lda #40
    jsr delay
    rts


; in:
; current_spell = spell
; player_offs = caster offset
; out:
; a = current_spell_chance = 0 <= x < 10
set_current_spell_chance:
    lda current_spell
    asl
    tay
    ; castch
    lda spelldata_packed + 1,y
    and #$f
    sta current_spell_chance

    ; apply world chaos
    ; chaos << 4
    lda spelldata_packed,y
    lsr
    lsr
    lsr
    lsr
    tax
    lda tbl_spelldata_chaos,x
    beq .set_current_spell_chance_world_done
    bmi +
    lda world_chaos
    bpl .set_current_spell_chance_apply_world
+   lda world_chaos
    bpl .set_current_spell_chance_world_done
    eor #$ff
    clc
    adc #1
.set_current_spell_chance_apply_world:
    lsr
    lsr
    clc
    adc current_spell_chance
    sta current_spell_chance
.set_current_spell_chance_world_done:

    ; apply player ability
    ldx player_offs
    lda player_data + PDATA_OFFS_ABILITY,x
    clc
    adc current_spell_chance

    ; limit to 0 <= x < 10
    bpl +
    lda #0
+   cmp #10
    bcc +
    lda #9
+   sta current_spell_chance
    rts


; in:
; player_i = current_player
; current_spell = spell to cast
; wcoord = caster coord
; acoord = target coord
; out:
; C = 1 if target ok
player_cast_ok:
    ; check if spell in range
    jsr is_spell_in_range
    bcs .player_cast_ok_not

    ; in range, so do some more checks
    ldx acoord
    lda arena_above,x
    beq ++
    lda current_spell
    cmp #SPELL_MAGIC_WOOD
    bcs .player_cast_ok_not
    lda arena_dead,x
    and #DEAD_MASK_IS_DEAD
    beq .player_cast_ok_not ; creature is not dead, can't cast here
++
    jsr is_tree_adjacent
    bcs .player_cast_ok_not
    jsr is_wall_adjacent
    bcs .player_cast_ok_not
    lda wcoord
    ldx #0  ; check LOS
    jsr los_blocked
    rts
.player_cast_ok_not:
    clc
    rts


; in:
; current_spell = spell to cast
; acoord = target coord
; out:
; C = 0 if no tree adjacent
is_tree_adjacent:
    lda current_spell
    cmp #SPELL_MAGIC_WOOD
    beq is_tree_adjacent_tree_spell
    cmp #SPELL_SHADOW_WOOD
    bne .is_tree_adjacent_no
is_tree_adjacent_tree_spell:
    ldx #7
-   lda acoord
    jsr apply_position_modifier
    cmp #$ff
    beq +
    tay
    lda arena_above,y
    cmp #SPELL_MAGIC_WOOD
    beq .is_tree_adjacent_yes
    cmp #SPELL_SHADOW_WOOD
    beq .is_tree_adjacent_yes
+   dex
    bpl -
.is_tree_adjacent_no:
    clc
    rts
.is_tree_adjacent_yes:
    sec
    rts


; check that the casting wizard isn't next to the wall target square
; NOTE: ignores cases where wizard is on a mount, tree, etc
; in:
; current_spell = spell to cast
; acoord = target coord
; out:
; C = 0 if no wall adjacent
is_wall_adjacent:
    lda current_spell
    cmp #SPELL_WALL
    bne .is_wall_adjacent_no
is_wall_adjacent_spell:
    lda player_i
    clc
    adc #WIZARD_INDEX
    sta .is_wall_adjacent_cmp
is_wall_adjacent_repeat:
+   ldx #7
-   lda acoord
    jsr apply_position_modifier
    cmp #$ff
    beq +
    tay
    lda arena_above,y
.is_wall_adjacent_cmp = * + 1
    cmp #SPELL_MAGIC_WOOD
    beq .is_wall_adjacent_yes
+   dex
    bpl -
.is_wall_adjacent_no:
    clc
    rts
.is_wall_adjacent_yes:
    sec
    rts


.DEBUG_LOS = 0
!if .DEBUG_LOS {
debug_los:
    stx .debug_los_x
    sty .debug_los_y
    lda ccoord
    ldy #0
    jsr print_hex
    lda acoord
    ldy #3
    jsr print_hex
    lda tcoord
    ldy #6
    jsr print_hex
    lda .debug_los_x
    ldy #9
    jsr print_hex1
    lda .debug_los_y
    ldy #10
    jsr print_hex1
    ldy .debug_los_y
    lda (mptr),y
    ldy #12
    jsr print_hex
-   jsr get_input
    beq -
.debug_los_x = * + 1
    ldx #0
.debug_los_y = * + 1
    ldy #0
    rts
}


; in:
; a = caster coord
; acoord = target coord
; x = bolt color / mode: 0 -> check collision, x>0 -> animate with color x
; out:
; C = 1 if LOS ok
los_blocked:
    cmp acoord
    bne +
    cpx #0
    bne +
    ; caster and target are the same square, LOS is ok
    sec
    rts
+   sta ccoord
    sta tcoord
    sta pcoord
    sty .los_blocked_smc_y

    ; prepare temp_d{,i[12]} MSB
    lda #0
    sta temp_dh
    sta temp_di1h
    sta temp_di2h

    ; setup mode flag
    cpx #0
    beq +
    stx .los_blocked_anim_color
    jsr print_setup_dst_area
    lda #$80
+   sta flag_anim

    ; calculate temp_[xy]
    lda tcoord
    ldx acoord
    jsr setup_yxd

    ; multiply temp_d[xy] by 8 for pixels coords
    ldx #3
-   asl temp_dx
    asl temp_dy
    dex
    bne -

    ; prepare temp_[xy]i[12]
    ldx #3
-   lda #$40
    sta temp_xi1,x
    dex
    bpl -

    ; calculate d etc
    ldy #0
    ldx temp_dx
    lda temp_dy
    cmp temp_dx
    bcc ++    ; dx >= dy
    ; dx < dy, swap a<->x
    sty temp_xi1
    tax
    lda temp_dx
    bcs +++ ; bra
++  ; dx >= dy
    sty temp_yi1
+++ ; a = min(dx, dy), x = max(dx, dy)
    sta zpdst   ; dmin = min(dx, dy)
    stx zpdsth  ; dmax = max(dx, dy)

    ; zploops <- dmax + 1
    inx
    stx zploops

    ; d <- dmin * 2 - dmax
    lda zpdst
    asl
    sec
    sbc zpdsth
    sta temp_d
    bcs +
    dec temp_dh
+
    ; di1 <- dmin * 2
    lda zpdst
    asl
    sta temp_di1

    ; di2 <- (dmin - dmax) * 2
    lda zpdst
    sec
    sbc zpdsth
    asl
    sta temp_di2
    bcc +
    dec temp_di2h
+

    ; move to right direction
    ldx #2  ; offset to temp_y{,i}1
-   lda temp_x1,x
    cmp temp_x2,x
    bcc +
    ; start[xy] >= end[xy], negate
    lda temp_xi1,x
    ora #$80
    sta temp_xi1,x
    lda temp_xi2,x
    ora #$80
    sta temp_xi2,x
+   dex
    dex
    bpl -

    ; setup x/y at offsets 3,3
    ldx #3
    ldy #3

los_blocked_new_square:
    stx temp_x1
    bit flag_anim
    bpl .los_blocked_do_coll
    ; redraw pcoord, draw tcoord
    sty temp_y1
    lda #4
    jsr delay
    ldy pcoord
    jsr arena_draw_square
.los_blocked_anim_color = * + 1
    lda #COLOR_BLUE
    sta color
.los_blocked_anim_char = * + 1
    lda #CHAR_RAY
    ldy tcoord
    sty pcoord
    ldx tbl_area_i_to_screen,y
    jsr print_char_dst_x
    ldy temp_y1
    jmp .los_blocked_new_square_done

.los_blocked_do_coll:
    ; new square: get collision mask
    ldx tcoord
    cpx ccoord
    beq .los_blocked_no_coll_square ; caster, no collision
    cpx acoord
    beq .los_blocked_no_coll_square ; target, no collision
    lda arena_dead,x
    and #DEAD_MASK_IS_DEAD
    bne .los_blocked_no_coll_square ; dead, no collision
    lda arena_above,x
    bne +   ; not branching works too due to the next lda #0
.los_blocked_no_coll_square:
    lda #0
+   jsr creature_get_collision
.los_blocked_new_square_done:
    ldx temp_x1

los_blocked_loop:
!if .DEBUG_LOS {
    jsr debug_los
}
    lda #0
    sta zptmp   ; <0 if new block

    bit flag_anim
    bmi +
    ; (if mode_coll) check if pixel is set in collision mask
    lda (mptr),y
    and bitmask,x
    beq +
    ; collision
    ldy .los_blocked_smc_y
    clc
    rts
+
    ; advance x/y
    bit temp_dh
    bpl +++
    ; d < 0
    lda temp_d
    clc
    adc temp_di1
    sta temp_d
    lda temp_dh
    adc temp_di1h
    sta temp_dh
    bit temp_xi1
    bvc ++
    bmi +
    inx
    bne ++  ; bra
+   dex
++
    bit temp_yi1
    bvc ++
    bmi +
    iny
    bne ++  ; bra
+   dey
++
    jmp los_blocked_loop_check_xy

+++ ; d >=0
    lda temp_d
    clc
    adc temp_di2
    sta temp_d
    lda temp_dh
    adc temp_di2h
    sta temp_dh
    bit temp_xi2
    bvc ++
    bmi +
    inx
    bne ++  ; bra
+   dex
++
    bit temp_yi2
    bvc ++
    bmi +
    iny
    bne ++  ; bra
+   dey
++

los_blocked_loop_check_xy:
    cpx #8
    bne ++
    ldx #0
    inc tcoord
    dec zptmp
++  cpx #-1
    bne ++
    ldx #7
    dec tcoord
    dec zptmp
++  cpy #8
    bne ++
    ; sec
    ldy #0
    lda tcoord
    adc #AREA_W - 1
    sta tcoord
    dec zptmp
++  cpy #-1
    bne ++
    ; sec
    ldy #7
    lda tcoord
    sbc #AREA_W
    sta tcoord
    dec zptmp
++
    ; next pixel
    dec zploops
    beq ++

    bit zptmp
    bmi +
    jmp los_blocked_loop
+   ; next square
    jmp los_blocked_new_square

++
    ; pixels done
    bit flag_anim
    bpl +
    ; redraw end point
    lda #4
    jsr delay
    ldy tcoord
    jsr arena_draw_square
+
    ; no collision
.los_blocked_smc_y = * + 1
    ldy #0
    sec
    rts


; in:
; current_spell_range = spell range + 1
; wcoord = caster coord
; acoord = target coord
; out:
; C = 0 if in range
is_spell_in_range:
    lda wcoord
    ldx acoord
    jsr get_distance
    cmp current_spell_range ; + 1 for also accepting distance == range
!if DEBUG_MAGIC_ALWAYS_WORKS > 0 {
    clc
}
    rts


; in:
; current_spell = spell to cast
; scoord = start coord
; acoord = target coord
spell_animation:
    lda #4
    jsr delay
    ; don't do spell line anim for wizard modifier spells
    lda current_spell
    cmp #SPELL_SHADOW_FORM + 1
    bcs .spell_animation_do_beam
    cmp #SPELL_MAGIC_SHIELD
    bcs ++
.spell_animation_do_beam:
    lda #SND_BEAM
    jsr sound_play
    lda scoord
    ldx #COLOR_BLUE
    jsr los_blocked
++
    lda #SND_SPELLSUCCESS
    jsr sound_play

    ldx #COLOR_BLUE
    ldy #GFX_ANIM_SPELL
    jmp gfx_animation


; in:
; acoord = target coord
; x = color
pop_animation:
    ldy #GFX_ANIM_POP
    jmp gfx_animation

; in:
; acoord = target coord
; x = color
splat_animation:
    ldy #GFX_ANIM_SPLAT
    jmp gfx_animation

} ; !zn Casting
