; creature (and goo/fire) related functions

!ifdef INCLUDE_CREATURE !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_CREATURE = 1
}

!zn Creature {

; x = target square
creature_spell_succeeds:
    lda current_spell
    cmp #SPELL_GOOEY_BLOB
    beq ++
    cmp #SPELL_MAGIC_FIRE
    beq ++
    ; whatever is in this square, place in arena_bflag
    lda arena_above,x
    sta arena_bflag,x
++
    lda current_spell
    sta arena_above,x
    lda #0
    sta arena_dead,x
    lda player_i
    bit temp_illusion_flag
    bpl +
    ora #AFLAG_MASK_ILLUSION
+   sta arena_aflag,x
    rts


spread_fire_blob:
    jsr print_setup_dst_area
    ldy #-1
.spread_fire_blob_loop:
    iny
    cpy #AREA_SIZE
    bne +
    rts
+   lda arena_aflag,y
    bmi .spread_fire_blob_loop  ; already moved
    and #AFLAG_MASK_OWNER
    sta player_i    ; owner
    lda arena_above,y
    cmp #SPELL_GOOEY_BLOB
    bcc .spread_fire_blob_loop
    cmp #SPELL_MAGIC_FIRE + 1
    bcs .spread_fire_blob_loop
    sta current_spell   ; creature type
    cmp #SPELL_MAGIC_FIRE
    ror flag_anim   ; b7: 1 -> fire, 0 -> goo
    sty acoord
    sty ccoord
    jsr get_random_10
    cmp #9
    bcc +
.spread_fire_blob_uncover:
    jsr uncover_square
    jmp .spread_fire_blob_loop
+   bit flag_anim
    bmi +   ; fire
    jsr get_random_10
    cmp #9
    bcs .spread_fire_blob_uncover
+   lda #8
    jsr get_random_a
    tax
    tya
    jsr apply_position_modifier
    ldy ccoord
    cmp #$ff
    beq .spread_fire_blob_loop
    sta acoord
    ldx ccoord
    ldy ccoord
    ; do in range check (XXX why?)
    jsr get_distance
    cmp #5
    bcs .spread_fire_blob_loop
    ldx acoord
    lda arena_above,x
    bne +
    jmp .spread_fire_blob_tests_done
+   sta best_spell  ; target creature
    cmp #WIZARD_INDEX
    bcc +
    ; target creature is a wizard
    ; sec
    sbc #WIZARD_INDEX
    cmp player_i
    beq .spread_fire_blob_loop  ; do nothing - own blob can't kill
.spread_fire_blob_kill_wizard:
    jsr kill_wizard
    ldy ccoord
    jmp .spread_fire_blob_tests_done
+   ; is NOT a wizard
    cmp #SPELL_MAGIC_WOOD
    beq .spread_fire_blob_uncover
    cmp #SPELL_MAGIC_CASTLE
    bcs .spread_fire_blob_uncover
    lda arena_dead,x
    lsr
    bcs .spread_fire_blob_tests_done
    ; if not dead
    lda arena_aflag,x
    and #AFLAG_MASK_OWNER
    cmp player_i
    beq .spread_fire_blob_loop_jump
    lda best_spell  ; target creature
    cmp #SPELL_HORSE
    bcc +++
    cmp #SPELL_MANTICORE + 1
    bcs +++
    lda arena_below,x
    cmp #WIZARD_INDEX
    bcc +++
    ; if the creature is a mount and has a wizard on it
    ; sec
    sbc #WIZARD_INDEX
    cmp player_i
    beq .spread_fire_blob_loop_jump ; do nothing - own blob can't kill
    ; clear arena_below (wizard) and place wizard in arena_above
    lda arena_below,x
    sta arena_above,x
    lda #0
    sta arena_below,x
    beq .spread_fire_blob_kill_wizard   ; bra
+++ bit flag_anim
    bpl +++
    ; fire
    ; get defence of target creature
    ; lda best_spell
    jsr creature_get_def
    ldy ccoord
    sta zptmp
    jsr get_random_10
    clc
    adc zptmp
    sta zptmp   ; defence
    jsr get_random_10
    clc
    adc #5
    cmp zptmp
    bcc .spread_fire_blob_tests_done
-   jmp .spread_fire_blob_uncover
+++ ; goo
    lda best_spell  ; target creature
    cmp #SPELL_MAGIC_FIRE
    bcs -
    ldx acoord
    lda arena_dead,x
    lsr
    bcs .spread_fire_blob_tests_done
    ; creature alive.. set arena_below with the current creature and cover it
    lda best_spell  ; target creature
    sta arena_below,x
    lda arena_aflag,x
    sta arena_bflag,x
.spread_fire_blob_tests_done:
    jsr do_spread
.spread_fire_blob_loop_jump:
    jmp .spread_fire_blob_loop

; in:
; y = start index
; acoord = target index
uncover_square:
    jsr get_random_10
    cmp #3
    bcc +
-   rts
+   ldx acoord
    lda arena_above,x
    cmp #SPELL_MAGIC_FIRE
    beq +
    jsr get_random_10
    cmp #4
    bcs -
+   ; remove the blob and show the creature underneath
    lda arena_below,y
    sta arena_above,y
    beq +
    lda arena_bflag,y
    sta arena_aflag,y
+   lda #0
    sta arena_below,y
    sta arena_bflag,y
    jsr arena_draw_square
    ldy ccoord
    lda #24
    jsr delay
    rts

; in:
; acoord = target coord
; y = ccoord = start coord
; current_spell = start creature
; flag_anim = start creature type, b7 == 1 -> fire
do_spread:
    ldx acoord
    lda current_spell
    sta arena_above,x
    lda #0
    sta arena_dead,x
    lda arena_aflag,y
    ora #AFLAG_MASK_MOVED   ; set spread flag
    sta arena_aflag,y
    sta arena_aflag,x

    lda #SND_GOOEY
    bit flag_anim
    bpl +
    lda #SND_FIRE
+   jsr sound_play

    ldy acoord
    jsr arena_draw_square

    lda #24
    jsr delay

    ; at the end of everything, randomly uncover the "spawn" square
    ldy ccoord
    sty acoord
    jsr uncover_square
    rts

} ; !zn Creature
