; spell/creature examine

!ifdef INCLUDE_EXAMINE !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_EXAMINE = 1
}

!zn Examine {

.text_casting_chance:
!tx "Casting chance=",0
text_range:
!tx "Range=",0
.text_dead:
!tx "(dead)",0

.text5:
TEXT5_OFFS_FLYIN = * - .text5
!tx "Flyin"
TEXT5_OFFS_MOUNT = * - .text5
!tx "Mount"
TEXT5_OFFS_UNDED = * - .text5
!tx "Unded"
TEXT5_OFFS_SHDOW = * - .text5
!tx "Shdow"
TEXT5_OFFS_ARMOR = * - .text5
!tx "Armor"
TEXT5_OFFS_SHIEL = * - .text5
!tx "Shiel"
TEXT5_OFFS_SWORD = * - .text5
!tx "Sword"
TEXT5_OFFS_KNIFE = * - .text5
!tx "Knife"


; acoord = square
examine_square:
    ; erase status/info
    jsr print_clear_status23
    jsr print_clear_info

    ; if not empty then draw status
    ldx acoord
    lda arena_above,x
    bne +
    rts
+   ; setup draw_stats_* params
    sta exdstmpa
    lda arena_below,x
    sta exdstmpy
    lda arena_aflag,x
    sta exdstmpx

    ; print creature/wizard name using owner color
    jsr print_setup_dst_statusline2
    lda exdstmpa
    cmp #WIZARD_INDEX
    bcc ++
    sec
    sbc #WIZARD_INDEX
    tay
    jsr print_wizard_name
    lda exdstmpa
    jmp .examine_draw_stats_wizard
++
    ; use corpse owner color if dead
    ldy acoord
    lda arena_dead,y
    and #DEAD_MASK_IS_DEAD
    beq +
    lda arena_dead,y
    and #DEAD_MASK_OWNER
    jmp ++
+   lda exdstmpx
    and #AFLAG_MASK_OWNER
++  tax
    lda wizard_color,x
    sta color
    lda exdstmpa
    jsr print_spellname_dst_ready
    ; print something if creature dead
    ldy acoord
    lda arena_dead,y
    and #DEAD_MASK_IS_DEAD
    beq +
    inx
    ldy #0
-   lda .text_dead,y
    beq +
    jsr print_char_dst_x
    iny
    bne -   ; bra
+   lda exdstmpa
    jmp .examine_draw_stats_creature


; current_spell = spell
; current_spell_chance = spell chance
examine_spell:
    ; erase status/info
    jsr print_clear_status123
    jsr print_clear_info

    ; draw name at bottom
    jsr print_setup_dst_statusline1
    lda current_spell
    jsr print_spellname
    jsr print_setup_dst_next_line

    ; draw law/chaos
    lda current_spell
    asl
    tay
    ; chaos << 4
    lda spelldata_packed,y
    lsr
    lsr
    lsr
    lsr
    tax
    lda tbl_spelldata_chaos,x
    beq +++
    pha
    bpl +
    ldy #COLOR_PURPLE
    ldx #<text_tok_chaos_
    lda #>text_tok_chaos_
    bne ++  ; bra
+   ldy #COLOR_CYAN
    ldx #<text_tok_law_
    lda #>text_tok_law_
++  stx zptxt
    sta zptxth
    sty color
    jsr print_packed_dst_ready
    pla
    clc
    bpl +
    eor #$ff
    adc #1
+   jsr print_num_dst_x
+++
    ; draw range
    lda #COLOR_YELLOW
    sta color
    lda #<text_range
    sta zptxt
    lda #>text_range
    sta zptxth
    ldx #9
    jsr print_packed_dst_ready_x
    lda #COLOR_WHITE
    sta color
    lda current_spell
    jsr spell_get_range_for_print
    jsr print_number
    jsr print_setup_dst_next_line

    ; draw cast chance
    lda #COLOR_GREEN
    sta color
    lda #<.text_casting_chance
    sta zptxt
    lda #>.text_casting_chance
    sta zptxth
    jsr print_packed_dst_ready

    lda #COLOR_WHITE
    sta color

    lda current_spell_chance
    clc
    adc #1
    jsr print_number
    lda #'0'
    jsr print_char_dst_x
    lda #'%'
    jsr print_char_dst_x

    ; if creature then draw_stats
    ldx #0
    ldy #0
    lda current_spell
    cmp #SPELL_KING_COBRA
    bcc +
    cmp #SPELL_GOOEY_BLOB
    bcc .examine_draw_stats
+   rts


; a = creature
; x = aflag
; y = below
.examine_draw_stats:
    sta exdstmpa
    stx exdstmpx
    sty exdstmpy

    ; if wizard ...
    cmp #WIZARD_INDEX
    bcc .examine_draw_stats_creature
    jmp .examine_draw_stats_wizard

.examine_draw_stats_creature:
    cmp #SPELL_GOOEY_BLOB
    bcs .examine_draw_stats_creature_inside ; do not draw stats of blobs, castles etc

    ; x = index to creature data
    asl
    asl
    tax
    ; combat << 4 | defence
    jsr .examine_get_stat_creature
    sta vmatrix + POS_INFOLINE + INFOOFFS_ATK
    sty vmatrix + POS_INFOLINE + INFOOFFS_DEF
    ; rangedc << 4 | rangedr
    jsr .examine_get_stat_creature
    sta vmatrix + POS_INFOLINE + INFOOFFS_RC
    sty vmatrix + POS_INFOLINE + INFOOFFS_RR
    ; movement << 4 | manvr
    jsr .examine_get_stat_creature
    sta vmatrix + POS_INFOLINE + INFOOFFS_MOV
    sty vmatrix + POS_INFOLINE + INFOOFFS_MAN
    ; magic res
    jsr .examine_get_stat_creature
    sty vmatrix + POS_INFOLINE + INFOOFFS_RES
    lda #' '
    sta vmatrix + POS_INFOLINE + INFOOFFS_RES + 1

    jsr .examine_stats_common

    ; flying: if (id >= SPELL_PEGASUS && id <= SPELL_GHOST)
    lda exdstmpa
    cmp #SPELL_PEGASUS
    bcc +
    cmp #SPELL_GHOST + 1
    bcs +
    ldy #TEXT5_OFFS_FLYIN
    jsr .examine_print_mod5
+
    ; mount: if (id >= SPELL_HORSE && id <= SPELL_MANTICORE)
    lda exdstmpa
    cmp #SPELL_HORSE
    bcc +
    cmp #SPELL_MANTICORE + 1
    bcs +
    ldy #TEXT5_OFFS_MOUNT
    jsr .examine_print_mod5
+
    ; undead: if ( (aflag & 0x40) ||  (id >= SPELL_VAMPIRE && id <= SPELL_ZOMBIE))
    bit exdstmpx
    bvs +
    lda exdstmpa
    cmp #SPELL_VAMPIRE
    bcc ++
    cmp #SPELL_ZOMBIE + 1
    bcs ++
+   ldy #TEXT5_OFFS_UNDED
    jsr .examine_print_mod5
++
.examine_draw_stats_creature_inside:
    ; draw any "inside" wizards - for mounts or trees/castles
    lda exdstmpy
    cmp #WIZARD_INDEX
    bcs +
    rts
+   jsr print_setup_dst_statusline2
    ldx #COLS - PNAME_LEN
    lda exdstmpy
    sec
    sbc #WIZARD_INDEX
    tay
    jsr print_wizard_name_offs_x
    ldx #COLS - (PNAME_LEN + 1)
    lda #'@'    ; CHAR_WIZARD
    jsr print_char_dst_x
    rts


.examine_draw_stats_wizard:
    ; x = index to wizard stats data
    sec
    sbc #WIZARD_INDEX
    sta exdstmpa
    tay
    ldx wizard_offs,y
    lda player_data + PDATA_OFFS_FLAGS1,x
    sta exdstmpx    ; flags

    ; combat << 4 | defence
    jsr .examine_get_stat_wizard
    sta vmatrix + POS_INFOLINE + INFOOFFS_ATK
    sty vmatrix + POS_INFOLINE + INFOOFFS_DEF
    ; rangedc << 4 | rangedr
    jsr .examine_get_stat_wizard
    sta vmatrix + POS_INFOLINE + INFOOFFS_RC
    sty vmatrix + POS_INFOLINE + INFOOFFS_RR
    ; movement << 4 | manvr
    jsr .examine_get_stat_wizard
    sta vmatrix + POS_INFOLINE + INFOOFFS_MOV
    sty vmatrix + POS_INFOLINE + INFOOFFS_MAN
    ; magic res
    jsr .examine_get_stat_wizard
    lda #' '
    cpy #'9' + 1
    bcc +
    tya
    sec
    sbc #10
    ldy #'1'
+   sta vmatrix + POS_INFOLINE + INFOOFFS_RES + 1
    sty vmatrix + POS_INFOLINE + INFOOFFS_RES

    jsr .examine_stats_common

    ; flying
    lda exdstmpx
    and #PDATA_MASK_FLAGS1_WINGS
    beq +
    ldy #TEXT5_OFFS_FLYIN
    jsr .examine_print_mod5
+
    ; shadow form
    lda exdstmpx
    and #PDATA_MASK_FLAGS1_SHADOW
    beq +
    ldy #TEXT5_OFFS_SHDOW
    jsr .examine_print_mod5
+
    ; armor | shield (flags & C0 == C0 | 40)
    ldy #TEXT5_OFFS_SHIEL
    lda exdstmpx
    and #(PDATA_MASK_FLAGS1_ARMOUR | PDATA_MASK_FLAGS1_SHIELD)
    beq ++
    bpl +
    ldy #TEXT5_OFFS_ARMOR
+   jsr .examine_print_mod5
++
    ; sword | knife (flags & 4|2)
    lda exdstmpx
    and #PDATA_MASK_FLAGS1_SWORD
    beq +
    ldy #TEXT5_OFFS_SWORD
    jsr .examine_print_mod5
    jmp ++
+   lda exdstmpx
    and #PDATA_MASK_FLAGS1_KNIFE
    beq ++
    ldy #TEXT5_OFFS_KNIFE
    jsr .examine_print_mod5
++

    ; draw name at bottom
    jsr print_setup_dst_statusline2
    ldy exdstmpa
    jsr print_wizard_name

    ; TODO spells
    ; TODO ability

    rts


.examine_stats_common:
    ldx #0
--  ldy #INFOLINE_W - 1
-   lda .tbl_examine_info_stat_color,y
    sta colorram + POS_INFOLINE,x
    inx
    dey
    bpl -
    txa
    clc
    adc #COLS - INFOLINE_W
    tax
    cpx #6 * COLS
    bne --
    lda #COLOR_CYAN
    sta colorram + POS_INFOLINE + INFOOFFS_RC
    sta colorram + POS_INFOLINE + INFOOFFS_RES

    ; setup printing
    ldx #<(vmatrix + POS_INFOLINE + INFOOFFS_VAR)
    ldy #>(vmatrix + POS_INFOLINE + INFOOFFS_VAR)
    jsr print_setup_dst_xy
    lda #COLOR_WHITE
    sta color
    rts

; reverse order
.tbl_examine_info_stat_color:
!by COLOR_CYAN, COLOR_WHITE, COLOR_WHITE, COLOR_WHITE, COLOR_WHITE

.examine_get_stat_wizard:
    lda player_data + PDATA_OFFS_COMBAT_DEF,x
    jmp .examine_get_stat
.examine_get_stat_creature:
    lda creaturedata_packed,x
.examine_get_stat:
    inx
    pha
    and #$f
    clc
    adc #'0'
    tay
    pla
    lsr
    lsr
    lsr
    lsr
    clc
    adc #'0'
    rts

.examine_print_mod5:
    ldx #0
-   lda .text5,y
    jsr print_char_dst_x
    iny
    cpx #5
    bne -
    jsr print_setup_dst_next_line
    rts

} ; !zn Examine
