; statusline menu handler

!ifdef INCLUDE_STATUSMENU !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_STATUSMENU = 1
}

!zn Statusmenu {

; in:
; x:y -> menu text list ("item1",0,"item2",0,"last",0,0)
; out:
; y = selected item
statusmenu:
    stx zptxt
    sty zptxth

    lda #0
    sta zploops
    sta menuitem

    ; setup printing
    ldx #<(vmatrix + POSY_STATUSLINE1 * COLS + 1)
    ldy #>(vmatrix + POSY_STATUSLINE1 * COLS + 1)
    jsr print_setup_dst_xy

    ; print (and count) menu items
    lda #COLOR_WHITE
    sta color

-   ldy #0
    lda (zptxt),y
    beq +
    jsr print_packed_dst_ready
    jsr print_setup_dst_next_line
    inc zploops
    bne -   ; bra
+

    ; setup printing
    ldx #<(vmatrix + POSY_STATUSLINE1 * COLS)
    ldy #>(vmatrix + POSY_STATUSLINE1 * COLS)
    jsr print_setup_dst_xy

    lda #3
    sta color

.statusmenu_loop:
    ; draw cursor
    ldy menuitem
    ldx text_line_area_offs,y
    lda #CHAR_MENUCURSOR
    jsr print_char_dst_x

    ; get input
.statusmenu_input:
    jsr get_input_wait_irq
    beq .statusmenu_input

    ldy menuitem
    cmp #INPUT_SELECT
    bne ++
    jsr print_clear_status
    rts

++  cmp #INPUT_U
    bne ++
    jsr text_erase_cursor
    dey
    bpl +
    ldy zploops
    dey
+   sty menuitem
    jmp .statusmenu_loop

++  cmp #INPUT_D
    bne .statusmenu_input
    jsr text_erase_cursor
    iny
    cpy zploops
    bne +
    ldy #0
+   sty menuitem
    jmp .statusmenu_loop

} ; !zn Statusmenu
