; wizard LUTs and functions

!ifdef INCLUDE_WIZARDS !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_WIZARDS = 1
}

!zn Wizards {

wizard_offs:
!for .i, 0, NUM_PLAYERS_MAX - 1 {
!by .i * PDATA_LEN
}

wizard_color:
!by COLOR_WHITE
!by COLOR_RED
!by COLOR_CYAN
!by COLOR_PURPLE
!by COLOR_GREEN
!by COLOR_BLUE
!by COLOR_YELLOW
!by COLOR_PURPLE


; in:
; acoord = wizard coord
kill_wizard:
    jsr print_setup_dst_area    ; TODO redundant?
    ldy acoord
    lda arena_above,y
    sec
    sbc #WIZARD_INDEX
    sta zptmp   ; wizard index
    tay
    ldx wizard_offs,y
    lda player_data + PDATA_OFFS_FLAGS1,x
    ora #PDATA_MASK_FLAGS1_DEAD
    sta player_data + PDATA_OFFS_FLAGS1,x
    ldy acoord
    lda arena_bflag,y
    sta arena_above,y
    lda #0
    sta arena_bflag,y

    lda #SND_SCREAM
    jsr sound_play
    ; TODO better animation
    ldy #100
    ldx #0
    jsr flash_anim
    lda #SND_URGH
    jsr sound_play
    lda #10
    jsr delay

    lda zptmp   ; wizard index
    jsr destroy_all_creatures
    rts

; in:
; player_offs = wizard data offset
; out:
; a = spell count
; optr:h -> spell list
get_wizard_spells:
    ; get spell table ptr
    ldx player_offs
    txa
    clc
    adc #<(player_data + PDATA_OFFS_SPELLS)
    sta optr
    lda #>(player_data + PDATA_OFFS_SPELLS)
    adc #0
    sta optrh
    ; get spell count
    lda player_data + PDATA_OFFS_SPELL_COUNT,x
    rts

; in:
; player_offs = wizard data offset
update_creaturecount:
    ldx player_offs
    lda round_count
    cmp #6
    bcs +
.update_creaturecount_0:
    lda #0
    sta player_data + PDATA_OFFS_TIMID,x
    rts
+   ldy #0
-   lda arena_above,y
    cmp #SPELL_KING_COBRA
    bcc ++
    cmp #SPELL_GOOEY_BLOB
    bcs ++
    ; is a creature
    lda arena_below,y
    sec
    sbc #WIZARD_INDEX
    cmp player_i
    bne ++
    ; is not a ridden creature
    lda arena_aflag,y
    and #AFLAG_MASK_OWNER
    cmp player_i
    beq .update_creaturecount_0
++  iny
    cpy #AREA_SIZE
    bne -
    ; if we are past round 6 and have no creatures
    ; then "be brave"...
    lda #$14    ; ??
    sta player_data + PDATA_OFFS_TIMID,x
    rts

} ; !zn Wizards
